﻿using System.Linq.Expressions;
using System.Windows.Controls;
using Telerik.Windows.Data;

namespace SortGroupByAggregate
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();

			this.playersGrid.ItemsSource = Club.GetPlayers();
		}

		private void RadButton_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			var descriptor = this.playersGrid.GroupDescriptors[0] as SortingGroupDescriptor;
			descriptor.SortFunction = descriptor.AggregateFunctions[0];
		}

		private void RadButton_Click_1(object sender, System.Windows.RoutedEventArgs e)
		{
			var descriptor = this.playersGrid.GroupDescriptors[0] as SortingGroupDescriptor;
			descriptor.SortFunction = descriptor.AggregateFunctions[1];
		}
	}


	public class SortingGroupDescriptor : GroupDescriptor
	{
		private AggregateFunction sortFunction;
		public AggregateFunction SortFunction
		{
			get
			{
				return sortFunction;
			}
			set
			{
				sortFunction = value;

				this.OnPropertyChanged("SortFunction");
			}
		}

		public override Expression CreateGroupSortExpression(Expression groupingExpression)
		{
			if (this.SortFunction != null)
			{
				return this.SortFunction.CreateAggregateExpression(groupingExpression);
			}
			else
			{
				return base.CreateGroupSortExpression(groupingExpression);
			}
		}
	}
}